# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import gamethread
import os
import playerlib
import popuplib
import cmdlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Map Change'
addon.basename = 'mapchange'
addon.status   = 1
addon.version  = '2.0.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

temp = {'round':'None'}
func.mpAddon(1, addon.basename)

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_%s' % addon.basename, 1)

	### Change Map CMD ###
	cmdlib.registerSayCommand('!changemap', changemapCMD, 'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_%s' % addon.basename, 0)

	### Cancel Load Delay ###
	gamethread.cancelDelayed('sam_mapchange_delay')

	### Unreg CMDs ###
	cmdlib.unregisterSayCommand('!changemap')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def changemapCMD(userid, args):
	if args:
		name = ' '.join(args)
		if name in getMapList(): changeMap(userid, {'id':1,'map':name}, None)
		else: func.tell(userid, func.lang_addon(addon.basename,'map_not_listed', {'map':name}), func.servertag)
	else: modulePopup(userid)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def addonPopup(userid):
	func.popupDelete('mapChange')
	popup = popuplib.easymenu('mapChange', None , mapChangeChoice)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s' % (func.menutitle, es.ServerVar(func.version), func.lang_addon(addon.basename,'maplist_desc')))
	for item in getMapList(): popup.addoption(item, item)
	popup.submenu(10, 'mainPage')
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def mapChangeChoice(userid, choice, popup):
	func.popupDelete('time_to_change')
	popup = popuplib.easymenu('time_to_change', None , changeMap)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s \n \n :: %s' % (func.menutitle, es.ServerVar(func.version), func.lang_addon(addon.basename,'whentochange_desc')))
	popup.addoption({'id':1,'map':choice}, func.lang_addon(addon.basename,'change_map_now'))
	popup.addoption({'id':2,'map':choice}, func.lang_addon(addon.basename,'change_map_roundend'))
	popup.submenu(10, 'mainPage')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def changeMap(userid, choice, popup):
	if choice['id'] == 1:
		func.hudhint('#human', func.lang_addon(addon.basename,'changing_to_map', {'map':choice['map']}))
		gamethread.delayedname(3, 'sam_mapchange_delay', es.server.insertcmd, ('changelevel %s' % choice['map']))
	else:
		func.tell('#all', func.lang_addon(addon.basename,'changing_map_roundend', {'map':choice['map']}), func.servertag)
		temp['round'] = choice['map']

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getMapList(): return [item.replace('.bsp','') for item in os.listdir('cstrike/maps/') if os.path.isfile('cstrike/maps/' + item) and item.endswith('.bsp')]

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_end(ev):
	if not temp['round'] == 'None':
		changeMap(None, {'id':1,'map':temp['round']}, None)
		temp['round'] = 'None'

# ============================================================================================================================================================= #