
# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import psyco
psyco.full()
import es
import popuplib
import os
import cmdlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Rules'
addon.basename = 'rules'
addon.status   = 1
addon.version  = '1.0.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES
file = 'cstrike/cfg/sam/rules.txt'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	### Rules CMD ###
	cmdlib.registerSayCommand('!rules', rulesCMD, 'SAM')

	### Create txt ###
	if os.path.isfile(file) == False:
		f = open(file,'w')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Rules file   #\n')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  This file contains all your server rules.\n')
		f.write('#\n')
		f.write('#  To add a rule,\n')
		f.write('#  Start the line with a - and the rule next to it.\n')
		f.write('#\n')
		f.write('#  Server rules are accessable in-game typing !rules.\n')
		f.write('# \n')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write(' \n')
		f.write('- Respect both Admins and Players.\n')
		f.write('- Do not spam the chat.\n')
		f.write('- Do not make noise with your mic.\n')
		f.write('- Cheat is totaly forbidden.\n')
		f.write('- Add the server to favourites.\n')
		f.write('- Have fun!\n')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

	### Unreg CMDs ###
	cmdlib.unregisterSayCommand('!rules')

	### Popups ###
	func.popupDelete('rules')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def rulesCMD(userid, args):
	func.popupDelete('rules')
	popup = popuplib.easymenu('rules', None , rulesChoice)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_addon(addon.basename, 'menu_title')))
	if len(getRules()) > 0:
		for item in getRules(): popup.addoption(item, item)
		popup.send(userid)
	else: func.tell(userid, func.lang_addon(addon.basename, 'no_rules_found'))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def rulesChoice(userid, choice, popup): func.popupDelete('rules')

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def getRules():
	if os.path.isfile(file) == True:
		with open(file) as f: return [line.replace('- ', '').replace('-', '') for line in f.readlines() if line.startswith('-') or line.startswith('- ')]
	else: return []

# ============================================================================================================================================================= #